# Broadcast a message using TTS (/en/api-reference/api-ref/conversational-ai/speak)

> For AI agents: see the complete documentation index at [llms.txt](/llms.txt).

Broadcasts a custom message through the TTS module.

- OpenAPI: /openapi/conversational-ai/rest-api.en.yaml
- Operation ID: agent-speak
- Method: POST
- Path: /v2/projects/{appid}/agents/{agentId}/speak
- Endpoint: https://api.agora.io/api/conversational-ai-agent/v2/projects/{appid}/agents/{agentId}/speak

## Servers

- https://api.agora.io/api/conversational-ai-agent

Use this endpoint to broadcast a custom message using the TTS module.

During a conversation with a Conversational AI agent, call this endpoint to immediately broadcast a custom message using the TTS module. Upon receiving the request, Conversational AI interrupts the agent’s speech and thought process to deliver the message. This broadcast can be interrupted by human voice.


:::info[Note]
The speak API is not supported when using `mllm` configuration.
:::

## Authorization

This endpoint requires authentication.

- `tokenAuth`
- `basicAuth`

## Parameters

- `appid` (path, required, string) - The App ID of the project.
- `agentId` (path, required, string) - The agent instance ID you obtained after successfully calling `join` to [Start a conversational AI agent](/en/api-reference/api-ref/conversational-ai/join).

## Request body

- `text` (string, required) - The broadcast message text. The maximum length of the text content is 512 bytes.
- `priority` (string) - Sets the priority of the message broadcast.

- `INTERRUPT`: High priority. The agent immediately interrupts the current interaction to announce the message.
- `APPEND`: Medium priority. The agent announces the message after the current interaction ends.
- `IGNORE`: Low priority. If the agent is busy interacting, it ignores and discards the broadcast; the message is only announced if the agent is not interacting.
  - Allowed: `INTERRUPT` | `APPEND` | `IGNORE`
  - Default: `INTERRUPT`
- `interruptable` (boolean) - Whether to allow users to interrupt the agent's broadcast by speaking:
- `true`: Allow
- `false`: Don't allow
  - Default: `true`

## Request examples

### curl

```bash
curl --request post \
        --url https://api.agora.io/api/conversational-ai-agent/v2/projects/:appid/agents/:agentId/speak \
        --header 'Authorization: Basic <credentials>' \
        --data '
      {
        "text": "Sorry, the conversation content is not compliant.",
        "priority": "INTERRUPT",
        "interruptable": false
      }'
```

### Python

```python
import requests

    url = "https://api.agora.io/api/conversational-ai-agent/v2/projects/:appid/agents/:agentId/speak"

    payload = {
        "text": "Sorry, the conversation content is not compliant.",
        "priority": "INTERRUPT",
        "interruptable": False
    }
    headers = {"Authorization": "Basic <credentials>"}

    response = requests.request("post", url, json=payload, headers=headers)

    print(response.text)
```

### Node.js

```javascript
const url = 'https://api.agora.io/api/conversational-ai-agent/v2/projects/:appid/agents/:agentId/speak';
    const options = {
      method: 'post',
      headers: { Authorization: 'Basic <credentials>' },
      body: JSON.stringify({
        text: 'Sorry, the conversation content is not compliant.',
        priority: 'INTERRUPT',
        interruptable: false
      })
    };

    fetch(url, options)
      .then(res => res.json())
      .then(json => console.log(json))
      .catch(err => console.error(err));
```


### Response

- If the returned status code is `200`, the request was successful. The response body is empty, and the agent starts to broadcast the specified message.

- If the returned status code is not `200`, the request failed. The response body includes the error code and description. Refer to [status codes](/en/api-reference/api-ref/conversational-ai/status-codes) to understand the possible reasons for failure.


## Responses

### 200

The request was successful. The response body contains the result of the request.

- `agent_id` (string) - Unique id of the agent instance.
- `channel` (integer) - The name of the channel.
- `start_ts` (integer) - Agent creation timestamp.
### default

The request failed. The response body includes the error details.

- `detail` (string) - Detailed error information.
- `reason` (string) - The reason for the failure.

## Response examples

### 200

```json
{
  "agent_id": "1NT29XxxxxxxxxELWEHC8OS",
  "channel": "test_channel",
  "start_ts": 1744877089
}
```
